#include <iostream>

#include <boost/bind.hpp>
#include <boost/function.hpp>
#include <boost/statechart/asynchronous_state_machine.hpp>
#include <boost/statechart/fifo_worker.hpp>
#include <boost/statechart/simple_state.hpp>
#include <boost/statechart/state_machine.hpp>
#include <boost/thread/thread.hpp>

class StateMachine;

class SuperState;

namespace boost {
namespace statechart {
template<>
inline void asynchronous_state_machine<StateMachine, SuperState>::initiate_impl() {}
}}

class StateMachine: public boost::statechart::asynchronous_state_machine<StateMachine, SuperState> {

public:
    StateMachine(my_context ctx) : my_base(ctx) {}

private:
    virtual void initiate_impl();
};

class SubState;

//MODIFICATION 1 of 3: UNCOMMENT THE FOLLOWING LINE
class SuperState: public boost::statechart::simple_state<SuperState, StateMachine, SubState> {

//MODIFICATION 2 of 3: COMMENT OUT THE FOLLOWING LINE
//class SuperState: public boost::statechart::simple_state<SuperState, StateMachine> {

public:

    SuperState(){
        std::cout<<"Entered into SuperState."<<std::endl;
    }

};

//MODIFICATION 3 of 3: COMMENT OUT THE FOLLOWING LINE
///*

class SubState: public boost::statechart::simple_state<SubState, SuperState> {

public:

    SubState(){
        std::cout<<"Entered into SubState."<<std::endl;
    }

};

/**/

void StateMachine::initiate_impl() {
    boost::statechart::state_machine<StateMachine, SuperState>::initiate();
}

int main() {
    std::cout<<"\n\nPress any key and then <CR> to exit\n\n"<<std::endl;
    char key;

    boost::statechart::fifo_scheduler<> scheduler(true);
    boost::statechart::fifo_scheduler<>::processor_handle handle = scheduler.create_processor<StateMachine> ();
    scheduler.initiate_processor(handle);
    boost::thread aThread(boost::bind(&boost::statechart::fifo_scheduler<>::operator(),&scheduler, 0));

    std::cin >> key;

    scheduler.destroy_processor(handle);
    scheduler.terminate();
    aThread.join();

    return 0;
}
